package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.TSSDGroup;
import com.sa.ibiz.demo.demo.domain.TSSDItem;

/**
 * 实体[TSSDGroupDetail] 数据对象
 */
@TableName(value = "T_SRFTSSDGROUPDETAIL",resultMap = "TSSDGroupDetailResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDGroupDetail extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDGroup tssdgroup;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDItem tssditem;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @TableId(value= "tssdgroupdetailid",type=IdType.UUID)//指定主键生成策略
    private String tssdgroupdetailid;
    private String tssdgroupdetailname;
    private String tssdgroupid;
    @TableField(exist = false)//逻辑属性
    private String tssdgroupname;
    private String tssditemid;
    @TableField(exist = false)//逻辑属性
    private String tssditemname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[任务时刻策略组明细标识]
     *  @param tssdgroupdetailid
     */
    public void setTssdgroupdetailid(String tssdgroupdetailid){
        if(StringUtils.isEmpty(tssdgroupdetailid))
            tssdgroupdetailid=null;
        this.tssdgroupdetailid = tssdgroupdetailid;
        this.set("tssdgroupdetailiddirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略组明细标识]
     */
    public String getTssdgroupdetailid(){
        return this.tssdgroupdetailid;
    }
    /**
     *  重置属性值[任务时刻策略组明细标识]
     */
    public void resetTssdgroupdetailid(){
        this.set("tssdgroupdetailiddirtyflag",false);
        this.tssdgroupdetailid = null;
    }
    /**
     *  设置属性值[任务时刻策略组明细名称]
     *  @param tssdgroupdetailname
     */
    public void setTssdgroupdetailname(String tssdgroupdetailname){
        if(StringUtils.isEmpty(tssdgroupdetailname))
            tssdgroupdetailname=null;
        this.tssdgroupdetailname = tssdgroupdetailname;
        this.set("tssdgroupdetailnamedirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略组明细名称]
     */
    public String getTssdgroupdetailname(){
        return this.tssdgroupdetailname;
    }
    /**
     *  重置属性值[任务时刻策略组明细名称]
     */
    public void resetTssdgroupdetailname(){
        this.set("tssdgroupdetailnamedirtyflag",false);
        this.tssdgroupdetailname = null;
    }
    /**
     *  设置属性值[任务时刻策略组]
     *  @param tssdgroupid
     */
    public void setTssdgroupid(String tssdgroupid){
        if(StringUtils.isEmpty(tssdgroupid))
            tssdgroupid=null;
        this.tssdgroupid = tssdgroupid;
        this.set("tssdgroupiddirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略组]
     */
    public String getTssdgroupid(){
        return this.tssdgroupid;
    }
    /**
     *  重置属性值[任务时刻策略组]
     */
    public void resetTssdgroupid(){
        this.set("tssdgroupiddirtyflag",false);
        this.tssdgroupid = null;
    }
    /**
     *  设置属性值[任务时刻策略组]
     *  @param tssdgroupname
     */
    public void setTssdgroupname(String tssdgroupname){
        if(StringUtils.isEmpty(tssdgroupname))
            tssdgroupname=null;
        this.tssdgroupname = tssdgroupname;
        this.set("tssdgroupnamedirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略组]
     */
    public String getTssdgroupname(){
        return this.tssdgroupname;
    }
    /**
     *  重置属性值[任务时刻策略组]
     */
    public void resetTssdgroupname(){
        this.set("tssdgroupnamedirtyflag",false);
        this.tssdgroupname = null;
    }
    /**
     *  设置属性值[任务时刻策略项]
     *  @param tssditemid
     */
    public void setTssditemid(String tssditemid){
        if(StringUtils.isEmpty(tssditemid))
            tssditemid=null;
        this.tssditemid = tssditemid;
        this.set("tssditemiddirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略项]
     */
    public String getTssditemid(){
        return this.tssditemid;
    }
    /**
     *  重置属性值[任务时刻策略项]
     */
    public void resetTssditemid(){
        this.set("tssditemiddirtyflag",false);
        this.tssditemid = null;
    }
    /**
     *  设置属性值[任务时刻策略项]
     *  @param tssditemname
     */
    public void setTssditemname(String tssditemname){
        if(StringUtils.isEmpty(tssditemname))
            tssditemname=null;
        this.tssditemname = tssditemname;
        this.set("tssditemnamedirtyflag",true);
    }
    /**
     *  获取属性值[任务时刻策略项]
     */
    public String getTssditemname(){
        return this.tssditemname;
    }
    /**
     *  重置属性值[任务时刻策略项]
     */
    public void resetTssditemname(){
        this.set("tssditemnamedirtyflag",false);
        this.tssditemname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[TSSDGroup]
     */
    public TSSDGroup getTssdgroup() {
        return tssdgroup;
    }
    /**
     *  设置主实体关联数据[TSSDGroup]
     */
    public void setTssdgroup(TSSDGroup tssdgroup) {
        this.tssdgroup = tssdgroup;
    }

     /**
     *  获取主实体关联数据[TSSDItem]
     */
    public TSSDItem getTssditem() {
        return tssditem;
    }
    /**
     *  设置主实体关联数据[TSSDItem]
     */
    public void setTssditem(TSSDItem tssditem) {
        this.tssditem = tssditem;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetTssdgroupdetailid();
        resetTssdgroupdetailname();
        resetTssdgroupid();
        resetTssdgroupname();
        resetTssditemid();
        resetTssditemname();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDGroupDetail copyTo(TSSDGroupDetail targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDGroupDetail.class, TSSDGroupDetail.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssdgroupdetailid();
		return targetEntity;
	}
}